#ifndef CGUL_LIST_P_H
#define CGUL_LIST_P_H

#include "cgul_common.h"
#include "cgul_list_node_p.h"
#include "cgul_list.h"
#include "cgul_cache.h"

CGUL_BEGIN_C

/**
 * Data encapsulated by the <code>cgul_list</code> class.
 */
struct cgul_list {

    /** The first node on the list. */
    cgul_list_node_t front;

    /** The last node on the list. */
    cgul_list_node_t back;

    /** Number of nodes on the list. */
    unsigned long int size;

    /**
     * For efficiency, the <code>cgul_list</code> can keep a cache of
     * nodes that can be reused.  In many situations, this can greatly
     * reduce the number of calls to <code>malloc()</code> which can
     * greatly improve performance and reduce memory fragmentation.
     */
    cgul_cache_t cache;

};

CGUL_END_C

#endif  /*  CGUL_LIST_P_H  */
