#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    int is_probably_prime = 0;
    unsigned long int count = 0;
    cgul_big_integer_t n = NULL;
    cgul_big_integer_t one = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    n = cgul_big_integer__new_from_string(&local, "0x10000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000");
    one = cgul_big_integer__new_from_long(&local, 1);
    if (local) {
        goto out;
    }

    for (i = 0 ; i < 100000 ; ++i) {
        /* Test if n is probably prime. */
        is_probably_prime = cgul_big_integer__is_probably_prime(&local, n, 25);
        if (local) {
            goto out;
        }

        /* Print the result of the test followed by n. */
        if (is_probably_prime) {
            ++count;
            printf("%lu: ", count);
            cgul_big_integer__print_as_hexadecimal(&local, n, stdout);
            puts("");
            break;
        } else {
            printf("n: ");
            cgul_big_integer__print_as_hexadecimal(&local, n, stdout);
            puts("");
        }

        /* Increment n. */
        cgul_big_integer__add(&local, n, n, one);
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg  = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (one) {
        cgul_big_integer__delete(one);
    }
    if (n) {
        cgul_big_integer__delete(n);
    }

    return rv;
}
