#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    const char* line = NULL;
    cgul_crlf_file_cxx f;

    try {

        /* Check usage. */
        if (argc == 1) {
            fprintf(stderr,
                    "Usage: main_crlf_file <file.txt> [<file.txt> ...]\n");

        } else {

            /* Iterate over the files passed in on the command line. */
            for (i = 1 ; i < argc ; ++i) {
                
                /* Open the file. */
                f.open_fname(argv[i]);

                /* Do not strip the UTF-8 byte-order mark. */
                //f.set_strip_utf8_bom(0);

                while ((line = f.get_line()) != NULL) {
                    cout << f.get_line_count() << ": "
                         << f.get_line_offset() << ": "
                         << line << endl;
                }

                /* Close the file. */
                f.close();
            }

        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    }

    return rv;
}
