#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    cgul_exception_t local = NULL;
    cgul_string_t s = NULL;

    s = cgul_string__new(&local);

    while (cgul_get_line_relaxed(&local, stdin, s) > 0) {
        char* tmp = cgul_string__get_value(&local, s);
        cgul_libc__printf(&local, "line = %s\n", tmp);
        cgul_string__set_value(&local, s, "");
    }

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
