#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* s = NULL;
    cgul_exception_t local = NULL;

    /* Force an out-of-memory condition. */
    cgul_libc__set_out_of_memory(&local, 1);

    /* Try to allocate memory indirectly. */
    s = cgul_libc__strdup(&local, "Hello, World!");
    if (local) {
        goto out;
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        free(s);
    }

    return rv;
}
