#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    int i = 0;
    char* tmp = NULL;
    cgul_exception_t local = NULL;
    cgul_list_t l = NULL;
    cgul_string_t s = NULL;
    

    s = cgul_string__new(&local);

    l = cgul_list__new(&local);
    cgul_list__set_cache_size(&local, l, 100);

    for (i = 0 ; i < 100 ; ++i) {
        cgul_string__append_sprintf(&local, s, "%d", i);
        tmp = cgul_string__get_value(&local, s);
        cgul_list__push_front(&local, l, (void*)tmp);
        if (local) {
            goto out;
        }
        cgul_string__take_value(&local, s);
    }

    while (!cgul_list__is_empty(&local, l)) {
        tmp = (char*)cgul_list__pop_front(&local, l);
        cgul_libc__printf(&local, "tmp = %s\n", tmp); fflush(stdout);
        if (tmp) {
            free(tmp);
        }
        if (local) {
            goto out;
        }
    }

    cgul_list__set_cache_size(&local, l, 50);

    for (i = 0 ; i < 100 ; ++i) {
        cgul_string__append_sprintf(&local, s, "%d", i);
        tmp = cgul_string__get_value(&local, s);
        cgul_list__push_front(&local, l, (void*)tmp);
        if (local) {
            goto out;
        }
        cgul_string__take_value(&local, s);
    }

    while (!cgul_list__is_empty(&local, l)) {
        tmp = (char *)cgul_list__pop_front(&local, l);
        cgul_libc__printf(&local, "tmp = %s\n", tmp); fflush(stdout);
        if (tmp) {
            free(tmp);
        }
        if (local) {
            goto out;
        }
    }

 out:

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (l) {
        cgul_list__delete(l);
    }

    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
