#include <iostream>
#include "cgul_cxx.h"

using namespace std;

static void
print_list(cgul_list_cxx* lst)
{
    cgul_list_node_cxx* curr = NULL;

    for (curr = lst->get_front() ; curr ; curr = curr->get_next()) {
        cout << (char*)curr->get_value() << endl;
    }

    cout << "=====" << endl;
}

int
main(int argc,
     char* argv[])
{
    int rv = 0;

    try {

        /* Create lists. */
        cgul_list_cxx lst1;
        cgul_list_cxx lst2;

        /* Insert strings into lst1 and sort. */
        lst1.push_back("foo");
        lst1.push_back("bar");
        lst1.push_back("baz");
        lst1.sort((cgul_list__compare_t)strcmp);

        /* Insert strings into lst1 and sort. */
        lst2.push_back("spam");
        lst2.push_back("eggs");
        lst2.push_back("baz");
        lst2.push_back("zzz");
        lst2.sort((cgul_list__compare_t)strcmp);

        /* Print the lists before merging. */
        print_list(&lst1);
        print_list(&lst2);

        /* Merge */
        lst1.merge(lst2, (cgul_list_cxx::compare_t)strcmp);

        /* Print the list after merging. */
        print_list(&lst1);
        print_list(&lst2);

        /* Print the sizes of each list. */
        printf("lst1.size() = %lu\n", lst1.get_size());
        printf("lst2.size() = %lu\n", lst2.get_size());

    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
