/**
 * This program generates 10M random unsigned 32-bit values and writes
 * them as text to standard output.
 */

#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    cgul_uint32_t next = 0;
    cgul_string_cxx s;
    cgul_random_lfg32_cxx prng;

    try {

        /* Generate 10M random unsigned 32-bit values and write them to
         * standard output as text. */
        for (i = 0 ; i < 10000000 ; ++i) {
            next = prng.next();
            printf("%#010x   bit1: %u\n", next, next & 0x1);
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
