#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* s = NULL;
    cgul_exception_t local = NULL;

    /* Check the command line. */
    if (argc != 2) {
        fprintf(stderr, "Usage: main_extension <path>\n");
        rv = 1;
        goto out;
    }

    /* Extract the extension from the path. */
    s = cgul_libc__rootname(&local, argv[1]);
    if (local) {
        goto out;
    }

    /* Print the result. */
    puts(s);

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        free(s);
    }

    return rv;
}
