#include "cgul.h"

int main(int argc,
         char* argv[])
{
    int rv = 0;
    size_t i = 0;
    size_t i_max = 0;
    const char* s = NULL;
    cgul_vector_t parts = NULL;
    char* part = NULL;
    cgul_exception_t local = NULL;

    /* Allocate a new vector to hold the parts returned by cgul_split(). */
    parts = cgul_vector__new(&local);
    if (local) {
        goto out;
    }

    /* Initialize the string to split. */
    s = "  Hello,   World! \n Goodbye,   Cruel  World! \n ";

    /* Split the string. */
    cgul_split(&local, s, " \t\n", 0 /* allow_empty_parts */, parts);
    if (local) {
        goto out;
    }

    /* Print the results. */
    i_max = cgul_vector__get_size(&local, parts);
    for (i = 0 ; i < i_max ; ++i) {
        part = cgul_vector__at(&local, parts, i);
        printf("parts[%lu] = \"%s\"\n", (unsigned long)i, part);
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up parts remembering to free each part. */
    if (parts) {
        while ((part = cgul_vector__pop_back(&local, parts)) != NULL) {
            free(part);
        }
        cgul_vector__delete(parts);
    }

    return rv;
}
