#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;

    try {

        cgul_string_cxx utf8;
        cgul_wstring_cxx utf32;

        /* Append the Unicode Byte-Order Mark to the UTF-32 string. */
        utf32.append_char(CGUL_WCHAR__BOM);

        /* Convert the UTF-32 string to UTF-8. */
        cgul_unicode_cxx::wcstombs(utf32.get_value(),
                                   utf32.get_length(),
                                   0, /* skip_bom */
                                   utf8);

        /* Print the UTF-8 string. */
        cout << utf8.get_value();

    } catch (const cgul_exception_cxx& e) {
        cerr << "Error: " << e.get_message() << endl;
        rv = 1;
    } catch (const exception& e) {
        cerr << "Error: " << e.what() << endl;
        rv = 1;
    }

    return rv;
}
