#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    cgul_vector_t v = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    v = cgul_vector__new(&local);
    if (local) {
        goto out;
    }

    /* Set the minimum capacity to 1. */
    cgul_vector__set_minimum_capacity(&local, v, 1);
    if (local) {
        goto out;
    }

    /* Create the vector one character at a time. */
    for (i = 0 ; i < 17 ; ++i) {

        /* Append the next NULL value. */
        cgul_vector__push_back(&local, v, NULL);
        if (local) {
            goto out;
        }

    }

    /* Reduce the size of the vector one value at a time. */
    for (i = cgul_vector__get_size(&local, v) ; i > 0 ; --i) {

        /* Reduce the size of the vector by one by removing the
         * trailing character. */
        cgul_vector__pop_back(&local, v);

    }

 out:

    /* Handle exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (v) {
        cgul_vector__delete(v);
    }

    return rv;
}
