#include "cgul.h"

int main(int argc,
         char* argvp[])
{
    int rv = 0;
    size_t i = 0;
    cgul_wchar_t hello[] = {'h', 'e', 'l', 'l', 'o', 0};
    cgul_wstring_t ws = NULL;
    cgul_exception_t local = NULL;

    ws = cgul_wstring__new(&local);
    cgul_wstring__append(&local, ws, hello);
    cgul_wstring__pad_right(&local, ws, 10, (cgul_wchar_t)' ');
    if (local) {
        goto out;
    }

#if 0
    /* Try to run off the end of the allocated buffer by appending one
     * character at a time. */
    for (i = 0 ; i < 10000 ; ++i) {
        cgul_wstring__append_char(&local, ws, (cgul_wchar_t)'z');
    }
#endif

    for (i = 0 ; i < cgul_wstring__get_length(&local, ws) ; ++i) {
        cgul_wchar_t c = cgul_wstring__get_value_at(&local, ws, i);
        printf("c = %lu\n", (long unsigned)c);
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (ws) {
        cgul_wstring__delete(ws);
    }

    return rv;
}
